Version 4.2.0.1, tag libreoffice-4.2.0.1
[LibreOffice.git] / solenv / bin / mkdocs.sh
blobee53fe4f4b1dc8a3b281c00a04dda25e245b732a
1 #!/usr/bin/env bash
3 # This file is part of the LibreOffice project.
5 # This Source Code Form is subject to the terms of the Mozilla Public
6 # License, v. 2.0. If a copy of the MPL was not distributed with this
7 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
9 # Doxygen / README doc generation
11 # See git for contributors
14 function header {
15 title=$1
16 breadcrumb=$2
17 output=$3
19 cat - > $output <<EOF
20 <!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
21 <html>
22 <head>
23 <title>$title</title>
25 <style>
26 * { margin: 0; padding: 0; }
27 body { font-family: sans-serif; font-size: 12px; }
28 #head { padding: 20px; background: #18A303; }
29 #head a { color: #000; }
30 #body { padding: 20px; }
31 #foot { padding: 10px; font-size: 9px; border-top: 1px #18A303 solid; margin-top: 25px; }
32 p { line-height: 1.7em; margin-bottom: 1em; }
33 pre { margin-bottom: 0.5em; }
34 .multi-col { -moz-column-width: 13em; -webkit-column-width: 13em; -moz-column-gap: 1em; -webkit-column-gap: 1em; }
35 h1 {margin-bottom: 0.5em;}
36 h2,h3,h4 { margin: 1.3em 0 0.5em 0; }
37 ul, ol { margin: 0.5em 1.5em; }
38 </style>
39 </head>
40 <body>
41 <div id="head">
42 <h1>$title</h1>
43 <p>$breadcrumb</p>
44 </div>
45 <div id="body">
46 EOF
49 function footer {
50 output=$1
52 cat - >> $output <<EOF
54 </div>
55 <div id="foot">
56 <small>
57 <p>Generated by Libreoffice <a href="http://cgit.freedesktop.org/libreoffice/core/plain/solenv/bin/mkdocs.sh">Module Description Tool</a></p>
58 <p>Last updated:
59 EOF
60 LANG= date >> $output
61 cat - >> $output <<EOF
62 </p>
63 </small>
64 </div>
65 </body>
66 </html>
67 EOF
71 function proc_text {
72 # Local links: [[...]]
73 # Git links: [git:...]
74 # Other remote links: [...]
75 # Headings: == bleh ==
76 # Paragraphs: \n\n
77 sed -re ' s/\[\[([-_a-zA-Z0-9]+)\]\]/<a href="\1.html">\1<\/a>/g' - \
78 | sed -re ' s/\[git:([^]]+)\]/<a href="http:\/\/cgit.freedesktop.org\/libreoffice\/core\/tree\/\1">\1<\/a>/g' \
79 | sed -re ' s/\[([^]]+)\]/<a href="\1">\1<\/a>/g' \
80 | sed -re ' s/====([^=]+)====/<h4>\1<\/h4>/g' \
81 | sed -re ' s/===([^=]+)===/<h3>\1<\/h3>/g' \
82 | sed -re ' s/==([^=]+)==/<h2>\1<\/h2>/g' \
83 | sed -re ':a;N;$!ba;s/\n\n/<\/p><p>/g' \
84 | awk 'BEGIN { print "<p>" } { print } END { print "</p>" }'
87 function setup {
88 parm=$1
89 if [ -z "${!parm}" ] ; then
90 echo "grep \"${parm}=\" ./config_host.mk | sed -re \" s/${parm}=//\")"
91 echo "$parm=$(grep \"${parm}=\" ./config_host.mk | sed -re \" s/${parm}=//\")"
92 eval "$parm=$(grep \"${parm}=\" ./config_host.mk | sed -re \" s/${parm}=//\")"
94 if [ -z "${!parm}" ] ; then
95 echo "could not determine $parm" >&2
96 exit 1
100 # binaries that we need
101 which doxygen > /dev/null 2>&1 || {
102 echo "You need doxygen for doc generation" >&2
103 exit 1
105 which dot > /dev/null 2>&1 || {
106 echo "You need the graphviz tools to create the nice inheritance graphs" >&2
107 exit 1
110 # suck setup
111 setup "SOLARINC"
112 shopt -s nullglob
114 # Title of the documentation
115 DOXYGEN_PROJECT_PREFIX="LibreOffice"
117 # get list of modules
118 INPUT_PROJECTS="`ls */Module_*.mk | sed 's#/.*##'`"
120 # output directory for generated documentation
121 BASE_OUTPUT="$1"
122 mkdir -p "$BASE_OUTPUT" || {
123 echo "Cannot create $BASE_OUTPUT"
124 exit 1
127 # paths for binary and configuration file
128 BASE_PATH=`pwd`
129 DOXYGEN_CFG="$2"
130 if test ! -f "$DOXYGEN_CFG"; then
131 echo "doxygen.cfg not found"
132 exit 1
135 # strip -I. and bin -I prefix; exlude system headers
136 DOXYGEN_INCLUDE_PATH=`echo $SOLARINC | sed -e 's/-I\.//g' -e 's/ -I/ /'g -e 's/ -isystem/ /g' -e 's|/usr/[^ ]*| |g'`
138 # setup version string
139 DOXYGEN_VERSION="master"
142 ###################################################
144 # Generate docs
146 ###################################################
148 # cleanup
149 echo "cleaning up" && rm -rf $BASE_OUTPUT/*
151 # make the stuff world-readable
152 umask 022
154 # generate docs
155 echo "generating doxygen docs"
156 DOXYGEN_REF_TAGFILES=""
157 for PROJECT in $INPUT_PROJECTS;
159 # avoid processing of full project subdirs, only add source and inc
160 DOXYGEN_INPUT=`printf "%s" "$PROJECT/source $PROJECT/inc include/$PROJECT "`
162 DOXYGEN_OUTPUT="$BASE_OUTPUT/$PROJECT"
163 DOXYGEN_OUR_TAGFILE="$DOXYGEN_OUTPUT/$PROJECT.tags"
164 DOXYGEN_PROJECTNAME="$DOXYGEN_PROJECT_PREFIX Module $PROJECT"
166 # export variables referenced in doxygen config file
167 export DOXYGEN_INPUT
168 export DOXYGEN_OUTPUT
169 export DOXYGEN_INCLUDE_PATH
170 export DOXYGEN_VERSION
171 export DOXYGEN_OUR_TAGFILE
172 export DOXYGEN_REF_TAGFILES
173 export DOXYGEN_PROJECTNAME
175 # debug
176 echo "Calling $DOXYGEN_PATH/doxygen $DOXYGEN_CFG with"
177 echo "Input: $DOXYGEN_INPUT"
178 echo "Output: $DOXYGEN_OUTPUT"
179 echo "Include: $DOXYGEN_INCLUDE_PATH"
180 echo "Version: $DOXYGEN_VERSION"
181 echo "Tagfile: $DOXYGEN_OUR_TAGFILE"
182 echo "Ref-Tags: $DOXYGEN_REF_TAGFILES"
183 echo "Title: $DOXYGEN_PROJECTNAME"
185 nice -15 doxygen "$DOXYGEN_CFG" >>$BASE_OUTPUT/doxygen.log || exit 1
187 # setup referenced tagfiles for next round
188 DOXYGEN_REF_TAGFILES="$DOXYGEN_REF_TAGFILES $DOXYGEN_OUR_TAGFILE=$BASE_URL/$PROJECT/html"
189 done
191 # generate entry page
192 echo "generating index page"
193 header "LibreOffice Modules" " " "$BASE_OUTPUT/index.html"
194 for module_name in *; do
195 if [ -d $module_name ]; then
196 cur_file=$(echo $module_name/README* $module_name/readme.txt*)
197 if [ -f "$cur_file" ]; then
198 # write index.html entry
199 text="<h2><a href=\"${module_name}.html\">${module_name}</a></h2>\n"
200 text="${text}$(head -n1 $cur_file | proc_text )"
201 echo -e $text >> "$BASE_OUTPUT/index.html"
203 # write detailed module content
204 header "$module_name" "<a href=\"index.html\">LibreOffice</a> &raquo; ${module_name}" "$BASE_OUTPUT/${module_name}.html"
205 text="<p><b>View module in:</b>"
206 text="${text} &nbsp; <a href=\"http://cgit.freedesktop.org/libreoffice/core/tree/${module_name}\">cgit</a>"
207 if $(echo $INPUT_PROJECTS | grep -q $module_name); then
208 text="${text} &nbsp; <a href=\"${module_name}/html/classes.html\">Doxygen</a>"
210 text="${text} </p><p>&nbsp;</p>"
211 echo -e $text >> "$BASE_OUTPUT/${module_name}.html"
212 proc_text < $cur_file >> "$BASE_OUTPUT/${module_name}.html"
213 footer "$BASE_OUTPUT/${module_name}.html"
214 else
215 empty_modules[${#empty_modules[*]}]=$module_name
218 done
219 if [ ${#empty_modules[*]} -gt 0 ]; then
220 echo -e "<p>&nbsp;</p><p>READMEs were not available for these modules:</p><ul>\n" >> "$BASE_OUTPUT/index.html"
221 for module_name in "${empty_modules[@]}"; do
222 echo -e "<li><a href=\"http://cgit.freedesktop.org/libreoffice/core/tree/${module_name}\">${module_name}</a></li>\n" >> "$BASE_OUTPUT/index.html"
223 done
224 echo -e "</ul>\n" >> "$BASE_OUTPUT/index.html"
227 footer "$BASE_OUTPUT/index.html"
229 ## done